import { useEffect, useState } from 'react';
import { Checkbox, Toggle } from '@fluentui/react';
import { fluentUiValidationMessageElement } from '../fluentUiValidationMessageElement';
import React from "react";
export const DynamicBooleanField = (props) => {
    var _a, _b, _c, _d, _e, _f, _g;
    const [value, setValue] = useState(props.value);
    useEffect(() => setValue(props.value), [props.value]);
    const onChange = (ev, value) => {
        setValue(value);
        props.onChange(value);
    };
    return (React.createElement(React.Fragment, null,
        ((_a = props.config) === null || _a === void 0 ? void 0 : _a.asToggle)
            ? React.createElement(Toggle
            // key={ props.key }
            , { 
                // key={ props.key }
                onText: (_c = (_b = props.config) === null || _b === void 0 ? void 0 : _b.textIfTrue) !== null && _c !== void 0 ? _c : "On", offText: (_e = (_d = props.config) === null || _d === void 0 ? void 0 : _d.textIfFalse) !== null && _e !== void 0 ? _e : "Off", onChange: onChange, defaultChecked: value, disabled: props.disabled })
            : React.createElement(Checkbox
            // key={ props.key }
            , { 
                // key={ props.key }
                label: !!value ? (_f = props.config) === null || _f === void 0 ? void 0 : _f.textIfTrue : (_g = props.config) === null || _g === void 0 ? void 0 : _g.textIfFalse, onChange: onChange, defaultChecked: value, disabled: props.disabled }),
        props.errorMessage &&
            fluentUiValidationMessageElement(props.errorMessage)));
};
//# sourceMappingURL=DynamicBooleanField.js.map