import { useEffect, useState } from 'react';
import { DatePicker } from '@fluentui/react';
import { fluentUiValidationMessageElement } from '../fluentUiValidationMessageElement';
import React from "react";
import { lang, FirstWeekOfYear, DayOfWeek } from '@wiberg/formbuilder';
export const DynamicDateField = (props) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m;
    const [value, setValue] = useState(props.value);
    useEffect(() => setValue(props.value), [props.value]);
    const onChange = (value) => {
        setValue(value);
        props.onChange(value);
    };
    return React.createElement(React.Fragment, null,
        React.createElement(DatePicker
        // key={props.key}
        , { 
            // key={props.key}
            placeholder: props.disabled ? "" : lang.texts.areas.form.dateDefaultPlaceholder, firstDayOfWeek: (_b = (_a = props.config) === null || _a === void 0 ? void 0 : _a.firstDayOfWeek) !== null && _b !== void 0 ? _b : DayOfWeek.Monday, showWeekNumbers: true, firstWeekOfYear: (_d = (_c = props.config) === null || _c === void 0 ? void 0 : _c.firstWeekOfYear) !== null && _d !== void 0 ? _d : FirstWeekOfYear.FirstFourDayWeek, showMonthPickerAsOverlay: true, isRequired: false, allowTextInput: true, formatDate: (_e = props.config) === null || _e === void 0 ? void 0 : _e.displayFormat, value: value != null && value != "0001-01-01T00:00:00" ? new Date(value) : undefined, onSelectDate: onChange, disabled: props.disabled, minDate: ((_f = props.config) === null || _f === void 0 ? void 0 : _f.minDate) ? (_g = props.config) === null || _g === void 0 ? void 0 : _g.minDate(props.parent) : undefined, maxDate: ((_h = props.config) === null || _h === void 0 ? void 0 : _h.maxDate) ? (_j = props.config) === null || _j === void 0 ? void 0 : _j.maxDate(props.parent) : undefined, calendarProps: { showGoToToday: true, strings: (_k = props.config) === null || _k === void 0 ? void 0 : _k.localizationStrings, restrictedDates: ((_l = props.config) === null || _l === void 0 ? void 0 : _l.restrictedDates) ? (_m = props.config) === null || _m === void 0 ? void 0 : _m.restrictedDates(props.parent) : undefined }, onBlur: () => props.onBlur(props.value) }),
        !!props.errorMessage &&
            fluentUiValidationMessageElement(props.errorMessage));
};
//# sourceMappingURL=DynamicDateField.js.map