var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { useEffect, useState } from 'react';
import { Dropdown } from '@fluentui/react';
import React from "react";
import { lang } from '@wiberg/formbuilder';
export const DynamicPredefinedArrayField = (props) => {
    var _a, _b, _c, _d, _e;
    const [value, setValue] = useState(props.value);
    useEffect(() => setValue(props.value), [props.value]);
    const [options, setOptions] = useState();
    useEffect(() => {
        var _a, _b, _c, _d;
        // async fetch of values
        let asyncGetter = (_b = (_a = props.config) === null || _a === void 0 ? void 0 : _a.predefinedOptions) === null || _b === void 0 ? void 0 : _b.optionsAsync;
        if (asyncGetter != null) {
            setOptions([{ key: -1, text: lang.texts.areas.common.loading }]);
            let fetch = () => __awaiter(void 0, void 0, void 0, function* () {
                try {
                    const options = yield asyncGetter(props.parent);
                    setOptions(options);
                }
                catch (error) {
                    setOptions([{ key: -1, text: lang.texts.areas.form.dropdownFailedFetch }]);
                    console.error(error);
                }
            });
            fetch();
        }
        // use static values
        else
            setOptions((_d = (_c = props.config) === null || _c === void 0 ? void 0 : _c.predefinedOptions) === null || _d === void 0 ? void 0 : _d.options);
    }, [(_a = props.config) === null || _a === void 0 ? void 0 : _a.predefinedOptions]);
    const onChange = (option) => {
        var _a, _b;
        if (option === undefined)
            return;
        let newValue = undefined;
        if ((_a = props.config) === null || _a === void 0 ? void 0 : _a.multiSelect) {
            let parsed = (_b = value) !== null && _b !== void 0 ? _b : [];
            let clone = [...parsed];
            if (option.selected)
                clone.push(option.key);
            else {
                const currIndex = clone.indexOf(option.key);
                if (currIndex > -1) {
                    clone.splice(currIndex, 1);
                }
            }
            newValue = clone;
        }
        else
            newValue = option.key;
        props.onChange(newValue);
    };
    return React.createElement(Dropdown, { disabled: props.disabled, multiSelect: (_c = (_b = props.config) === null || _b === void 0 ? void 0 : _b.multiSelect) !== null && _c !== void 0 ? _c : false, options: options !== null && options !== void 0 ? options : [], selectedKey: ((_d = props.config) === null || _d === void 0 ? void 0 : _d.multiSelect) ? undefined : value, selectedKeys: ((_e = props.config) === null || _e === void 0 ? void 0 : _e.multiSelect) ? value : undefined, onChange: (event, option, index) => onChange(option), errorMessage: props.errorMessage });
};
//# sourceMappingURL=DynamicPredefinedArrayField.js.map