import { forwardRef } from "react";
import { Dialog, DialogFooter, Panel, PanelType } from '@fluentui/react';
import React from "react";
import { Form, FormBuilderListEditorType } from "@wiberg/formbuilder";
import { FluentDialogContentWrapper } from "./components/FluentDialogContentWrapper";
export const FluentDialog = forwardRef((props, ref) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8;
    return (((_a = props.editorConfig) === null || _a === void 0 ? void 0 : _a.containerOptions.type) == FormBuilderListEditorType.Dialog
        ?
            React.createElement(Dialog, { key: `${props.keyPrefix}-listitemdialog`, minWidth: (_c = (_b = props.editorConfig) === null || _b === void 0 ? void 0 : _b.containerOptions.customWidth) !== null && _c !== void 0 ? _c : 800, hidden: false, title: (_d = props.editorConfig) === null || _d === void 0 ? void 0 : _d.title(props.item, props.newItemMode), onDismiss: () => props.show(false), dialogContentProps: {
                    subText: (_e = props.editorConfig) === null || _e === void 0 ? void 0 : _e.description
                }, modalProps: {
                    isBlocking: true
                } },
                React.createElement(React.Fragment, null,
                    React.createElement(FluentDialogContentWrapper, { key: `${props.keyPrefix}-formwrapper`, renderDelay: (_h = (_g = (_f = props.editorConfig) === null || _f === void 0 ? void 0 : _f.containerOptions) === null || _g === void 0 ? void 0 : _g.contentWrapper) === null || _h === void 0 ? void 0 : _h.renderDelay, fallback: (_l = (_k = (_j = props.editorConfig) === null || _j === void 0 ? void 0 : _j.containerOptions) === null || _k === void 0 ? void 0 : _k.contentWrapper) === null || _l === void 0 ? void 0 : _l.fallback },
                        React.createElement(Form, Object.assign({ key: `${props.keyPrefix}-listitemdialogform`, ref: ref }, props.formListProps, { validationResult: undefined, item: ((_o = (_m = props.editorConfig) === null || _m === void 0 ? void 0 : _m.dynamicForm) === null || _o === void 0 ? void 0 : _o.useEmptyItem)
                                ? {}
                                : (_p = props.item) !== null && _p !== void 0 ? _p : {}, dynamicSchema: ((_q = props.editorConfig) === null || _q === void 0 ? void 0 : _q.dynamicForm) == null
                                ? undefined
                                : {
                                    // semi-override dynamickey function, due to item reset, if using 'useEmptyItem'
                                    dynamicKey: (item) => { var _a, _b; return (_b = (_a = props.editorConfig) === null || _a === void 0 ? void 0 : _a.dynamicForm) === null || _b === void 0 ? void 0 : _b.dynamicKey(item != null && Object.keys(item).length ? item : props.item); },
                                    schemaConfig: (_s = (_r = props.editorConfig) === null || _r === void 0 ? void 0 : _r.dynamicForm) === null || _s === void 0 ? void 0 : _s.schemaConfig
                                } // argh!! the types do nothing :| (ewi)
                         }))),
                    React.createElement(DialogFooter, null, props.onRenderFooterContent())))
        :
            React.createElement(Panel, { key: `${props.keyPrefix}-listitempanel`, isOpen: true, onDismiss: () => props.show(false), isLightDismiss: false, type: (_u = (_t = props.editorConfig) === null || _t === void 0 ? void 0 : _t.containerOptions.panelSize) !== null && _u !== void 0 ? _u : PanelType.medium, customWidth: (_v = props.editorConfig) === null || _v === void 0 ? void 0 : _v.containerOptions.customWidth, className: "tp-panel tp-panel-editor", headerText: (_w = props.editorConfig) === null || _w === void 0 ? void 0 : _w.title(props.item, props.newItemMode), layerProps: {}, overlayProps: {}, focusTrapZoneProps: {}, isBlocking: true, onOuterClick: (e) => { e.preventDefault(); e.stopPropagation(); return false; }, onRenderFooterContent: props.onRenderFooterContent, isFooterAtBottom: true, styles: { header: { paddingBottom: "30px" }, footerInner: { borderTop: "1px solid rgb(237, 235, 233)" } } },
                React.createElement(FluentDialogContentWrapper, { key: `${props.keyPrefix}-formwrapper`, renderDelay: (_z = (_y = (_x = props.editorConfig) === null || _x === void 0 ? void 0 : _x.containerOptions) === null || _y === void 0 ? void 0 : _y.contentWrapper) === null || _z === void 0 ? void 0 : _z.renderDelay, fallback: (_2 = (_1 = (_0 = props.editorConfig) === null || _0 === void 0 ? void 0 : _0.containerOptions) === null || _1 === void 0 ? void 0 : _1.contentWrapper) === null || _2 === void 0 ? void 0 : _2.fallback },
                    React.createElement(Form, Object.assign({ key: `${props.keyPrefix}-listitempanelform`, ref: ref }, props.formListProps, { validationResult: undefined, item: ((_4 = (_3 = props.editorConfig) === null || _3 === void 0 ? void 0 : _3.dynamicForm) === null || _4 === void 0 ? void 0 : _4.useEmptyItem)
                            ? {}
                            : (_5 = props.item) !== null && _5 !== void 0 ? _5 : {}, dynamicSchema: ((_6 = props.editorConfig) === null || _6 === void 0 ? void 0 : _6.dynamicForm) == null
                            ? undefined
                            : {
                                // semi-override dynamickey function, due to item reset, if using 'useEmptyItem'
                                dynamicKey: (item) => { var _a, _b; return (_b = (_a = props.editorConfig) === null || _a === void 0 ? void 0 : _a.dynamicForm) === null || _b === void 0 ? void 0 : _b.dynamicKey(item != null && Object.keys(item).length ? item : props.item); },
                                schemaConfig: (_8 = (_7 = props.editorConfig) === null || _7 === void 0 ? void 0 : _7.dynamicForm) === null || _8 === void 0 ? void 0 : _8.schemaConfig
                            } })))));
});
//# sourceMappingURL=FluentDialog.js.map