import { useEffect, useState } from 'react';
import { mergeStyles, MessageBar, MessageBarType, Shimmer, ShimmerElementType } from '@fluentui/react';
import React from "react";
import { useIsMounted, lang } from '@wiberg/formbuilder';
const wrapperClass = mergeStyles({
    padding: 2,
    selectors: {
        '& > .ms-Shimmer-container': {
            margin: '5px 0',
        },
    },
});
const shimmerLabel = [
    { type: ShimmerElementType.line, height: 20 },
];
const shimmerInput = [
    { type: ShimmerElementType.line, height: 30 },
];
const propertyShimmer = (idx) => (React.createElement("div", { className: wrapperClass, key: `formbuilder-shimmer-line-${idx}` },
    React.createElement(Shimmer, { shimmerElements: shimmerLabel, width: "35%" }),
    React.createElement(Shimmer, { shimmerElements: shimmerInput })));
export const FluentFormShimmer = props => {
    var _a;
    const [timedOut, setTimedOut] = useState(false);
    const isMounted = useIsMounted();
    useEffect(() => {
        var _a;
        setTimeout(() => {
            if (!isMounted())
                return;
            setTimedOut(true);
        }, (_a = props.timeout) !== null && _a !== void 0 ? _a : 2000);
    }, []);
    return (timedOut
        ? React.createElement(MessageBar, { key: "formbuilder-shimmer-bar", messageBarType: MessageBarType.error, styles: { root: { width: "100%" } } }, (_a = props.timeoutMessage) !== null && _a !== void 0 ? _a : lang.texts.areas.common.schemaNotFound)
        : React.createElement("div", { style: { paddingBottom: "10px" }, key: "formbuilder-shimmer" }, [1, 2, 3, 4, 5].map((_, idx) => propertyShimmer(idx))));
};
//# sourceMappingURL=FluentFormShimmer.js.map